import { e as entityKind } from './alias-f3b5fd3d.mjs';
export { bH as BaseName, p as Column, aV as ColumnAliasProxyHandler, C as ColumnBuilder, bF as Columns, D as DrizzleError, bJ as ExtraConfigBuilder, br as FakePrimitiveParam, bI as IsAlias, M as Many, bu as Name, O as One, bG as OriginalName, b as Param, bB as Placeholder, Q as QueryPromise, bm as Relation, aW as RelationTableAliasProxyHandler, bn as Relations, S as SQL, bE as Schema, j as SelectionProxyHandler, bt as StringChunk, r as Subquery, u as SubqueryConfig, T as Table, n as TableAliasProxyHandler, bD as TableName, l as TransactionRollbackError, v as View, V as ViewBaseConfig, W as WithSubquery, aX as aliasedRelation, G as aliasedTable, w as aliasedTableColumn, E as and, H as applyMixins, bi as arrayContained, bh as arrayContains, bj as arrayOverlaps, bk as asc, bb as between, aZ as bindIfParam, bq as createMany, bp as createOne, c as createTableRelationsHelpers, bl as desc, F as eq, b9 as exists, a as extractTablesRelationalConfig, f as fillPlaceholders, x as getOperators, A as getOrderByOperators, I as getTableColumns, K as getTableLikeName, q as getTableName, b1 as gt, b2 as gte, aY as hasOwnEntityKind, bL as iife, bf as ilike, b5 as inArray, i as is, bw as isDriverValueEncoder, b8 as isNotNull, b7 as isNull, bs as isSQLWrapper, bK as isTable, bd as like, b3 as lt, b4 as lte, z as mapColumnsInAliasedSQLToAlias, y as mapColumnsInSQLToAlias, g as mapRelationalRow, m as mapResultRow, d as mapUpdateSet, bv as name, a_ as ne, bx as noopDecoder, by as noopEncoder, bz as noopMapper, B as normalizeRelation, b0 as not, bc as notBetween, ba as notExists, bg as notIlike, b6 as notInArray, be as notLike, a$ as or, o as orderSelectedFields, bA as param, bC as placeholder, bo as relations, s as sql } from './alias-f3b5fd3d.mjs';

class ConsoleLogWriter {
    static [entityKind] = 'ConsoleLogWriter';
    write(message) {
        console.log(message);
    }
}
class DefaultLogger {
    static [entityKind] = 'DefaultLogger';
    writer;
    constructor(config) {
        this.writer = config?.writer ?? new ConsoleLogWriter();
    }
    logQuery(query, params) {
        const stringifiedParams = params.map((p) => {
            try {
                return JSON.stringify(p);
            }
            catch {
                return String(p);
            }
        });
        const paramsStr = stringifiedParams.length ? ` -- params: [${stringifiedParams.join(', ')}]` : '';
        this.writer.write(`Query: ${query}${paramsStr}`);
    }
}
class NoopLogger {
    static [entityKind] = 'NoopLogger';
    logQuery() {
        // noop
    }
}

export { ConsoleLogWriter, DefaultLogger, NoopLogger, entityKind };
//# sourceMappingURL=index.mjs.map
