import { L as PgColumnBuilder, e as entityKind, N as PgColumn, n as TableAliasProxyHandler, R as pgTableWithSchema, U as pgViewWithSchema, X as pgMaterializedViewWithSchema, i as is, T as Table, Y as PgTable, Z as UniqueConstraintBuilder, _ as PrimaryKeyBuilder, $ as ForeignKeyBuilder, V as ViewBaseConfig, a0 as PgViewConfig, a1 as PgMaterializedViewConfig } from '../alias-f3b5fd3d.mjs';
export { aK as DefaultViewBuilderCore, au as ForeignKey, aA as InlineForeignKeys, aP as ManualMaterializedViewBuilder, aM as ManualViewBuilder, aO as MaterializedViewBuilder, aN as MaterializedViewBuilderCore, a3 as PgArray, a2 as PgArrayBuilder, a5 as PgDate, a4 as PgDateBuilder, a7 as PgDateString, a6 as PgDateStringBuilder, P as PgDialect, aa as PgJson, a9 as PgJsonBuilder, ad as PgJsonb, ac as PgJsonbBuilder, aS as PgMaterializedView, ag as PgNumeric, af as PgNumericBuilder, az as PgSelectBase, k as PgSelectBuilder, ay as PgSelectQueryBuilderBase, ak as PgTime, aj as PgTimeBuilder, an as PgTimestamp, am as PgTimestampBuilder, ap as PgTimestampString, ao as PgTimestampStringBuilder, as as PgUUID, ar as PgUUIDBuilder, aR as PgView, aQ as PgViewBase, ax as PrimaryKey, h as QueryBuilder, aG as UniqueConstraint, aF as UniqueOnConstraintBuilder, aL as ViewBuilder, a8 as date, ai as decimal, av as foreignKey, ab as json, ae as jsonb, aJ as makePgArray, ah as numeric, aI as parsePgArray, aH as parsePgNestedArray, aU as pgMaterializedView, aB as pgTable, aC as pgTableCreator, aT as pgView, aw as primaryKey, al as time, aq as timestamp, aD as unique, aE as uniqueKeyName, at as uuid } from '../alias-f3b5fd3d.mjs';
export { c as PgDatabase, d as PgDeleteBase, f as PgInsertBase, e as PgInsertBuilder, g as PgRefreshMaterializedView, a as PgSession, b as PgTransaction, i as PgUpdateBase, h as PgUpdateBuilder, P as PreparedQuery } from '../session-603b1d82.mjs';

class PgBigInt53Builder extends PgColumnBuilder {
    static [entityKind] = 'PgBigInt53Builder';
    constructor(name) {
        super(name, 'number', 'PgBigInt53');
    }
    /** @internal */
    build(table) {
        return new PgBigInt53(table, this.config);
    }
}
class PgBigInt53 extends PgColumn {
    static [entityKind] = 'PgBigInt53';
    getSQLType() {
        return 'bigint';
    }
    mapFromDriverValue(value) {
        if (typeof value === 'number') {
            return value;
        }
        return Number(value);
    }
}
class PgBigInt64Builder extends PgColumnBuilder {
    static [entityKind] = 'PgBigInt64Builder';
    constructor(name) {
        super(name, 'bigint', 'PgBigInt64');
    }
    /** @internal */
    build(table) {
        return new PgBigInt64(table, this.config);
    }
}
class PgBigInt64 extends PgColumn {
    static [entityKind] = 'PgBigInt64';
    getSQLType() {
        return 'bigint';
    }
    // eslint-disable-next-line unicorn/prefer-native-coercion-functions
    mapFromDriverValue(value) {
        return BigInt(value);
    }
}
function bigint(name, config) {
    if (config.mode === 'number') {
        return new PgBigInt53Builder(name);
    }
    return new PgBigInt64Builder(name);
}

class PgBigSerial53Builder extends PgColumnBuilder {
    static [entityKind] = 'PgBigSerial53Builder';
    constructor(name) {
        super(name, 'number', 'PgBigSerial53');
        this.config.hasDefault = true;
        this.config.notNull = true;
    }
    /** @internal */
    build(table) {
        return new PgBigSerial53(table, this.config);
    }
}
class PgBigSerial53 extends PgColumn {
    static [entityKind] = 'PgBigSerial53';
    getSQLType() {
        return 'bigserial';
    }
    mapFromDriverValue(value) {
        if (typeof value === 'number') {
            return value;
        }
        return Number(value);
    }
}
class PgBigSerial64Builder extends PgColumnBuilder {
    static [entityKind] = 'PgBigSerial64Builder';
    constructor(name) {
        super(name, 'bigint', 'PgBigSerial64');
        this.config.hasDefault = true;
    }
    /** @internal */
    build(table) {
        return new PgBigSerial64(table, this.config);
    }
}
class PgBigSerial64 extends PgColumn {
    static [entityKind] = 'PgBigSerial64';
    getSQLType() {
        return 'bigserial';
    }
    // eslint-disable-next-line unicorn/prefer-native-coercion-functions
    mapFromDriverValue(value) {
        return BigInt(value);
    }
}
function bigserial(name, { mode }) {
    if (mode === 'number') {
        return new PgBigSerial53Builder(name);
    }
    return new PgBigSerial64Builder(name);
}

class PgBooleanBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgBooleanBuilder';
    constructor(name) {
        super(name, 'boolean', 'PgBoolean');
    }
    /** @internal */
    build(table) {
        return new PgBoolean(table, this.config);
    }
}
class PgBoolean extends PgColumn {
    static [entityKind] = 'PgBoolean';
    getSQLType() {
        return 'boolean';
    }
}
function boolean(name) {
    return new PgBooleanBuilder(name);
}

class PgCharBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgCharBuilder';
    constructor(name, config) {
        super(name, 'string', 'PgChar');
        this.config.length = config.length;
        this.config.enumValues = config.enum;
    }
    /** @internal */
    build(table) {
        return new PgChar(table, this.config);
    }
}
class PgChar extends PgColumn {
    static [entityKind] = 'PgChar';
    length = this.config.length;
    enumValues = this.config.enumValues;
    getSQLType() {
        return this.length === undefined ? `char` : `char(${this.length})`;
    }
}
function char(name, config = {}) {
    return new PgCharBuilder(name, config);
}

class PgCidrBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgCidrBuilder';
    constructor(name) {
        super(name, 'string', 'PgCidr');
    }
    /** @internal */
    build(table) {
        return new PgCidr(table, this.config);
    }
}
class PgCidr extends PgColumn {
    static [entityKind] = 'PgCidr';
    getSQLType() {
        return 'cidr';
    }
}
function cidr(name) {
    return new PgCidrBuilder(name);
}

class PgCustomColumnBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgCustomColumnBuilder';
    constructor(name, fieldConfig, customTypeParams) {
        super(name, 'custom', 'PgCustomColumn');
        this.config.fieldConfig = fieldConfig;
        this.config.customTypeParams = customTypeParams;
    }
    /** @internal */
    build(table) {
        return new PgCustomColumn(table, this.config);
    }
}
class PgCustomColumn extends PgColumn {
    static [entityKind] = 'PgCustomColumn';
    sqlName;
    mapTo;
    mapFrom;
    constructor(table, config) {
        super(table, config);
        this.sqlName = config.customTypeParams.dataType(config.fieldConfig);
        this.mapTo = config.customTypeParams.toDriver;
        this.mapFrom = config.customTypeParams.fromDriver;
    }
    getSQLType() {
        return this.sqlName;
    }
    mapFromDriverValue(value) {
        return typeof this.mapFrom === 'function' ? this.mapFrom(value) : value;
    }
    mapToDriverValue(value) {
        return typeof this.mapTo === 'function' ? this.mapTo(value) : value;
    }
}
/**
 * Custom pg database data type generator
 */
function customType(customTypeParams) {
    return (dbName, fieldConfig) => {
        return new PgCustomColumnBuilder(dbName, fieldConfig, customTypeParams);
    };
}

class PgDoublePrecisionBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgDoublePrecisionBuilder';
    constructor(name) {
        super(name, 'number', 'PgDoublePrecision');
    }
    /** @internal */
    build(table) {
        return new PgDoublePrecision(table, this.config);
    }
}
class PgDoublePrecision extends PgColumn {
    static [entityKind] = 'PgDoublePrecision';
    getSQLType() {
        return 'double precision';
    }
    mapFromDriverValue(value) {
        if (typeof value === 'string') {
            return Number.parseFloat(value);
        }
        return value;
    }
}
function doublePrecision(name) {
    return new PgDoublePrecisionBuilder(name);
}

const isPgEnumSym = Symbol.for('drizzle:isPgEnum');
function isPgEnum(obj) {
    return !!obj && typeof obj === 'function' && isPgEnumSym in obj && obj[isPgEnumSym] === true;
}
class PgEnumColumnBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgEnumColumnBuilder';
    constructor(name, enumInstance) {
        super(name, 'string', 'PgEnumColumn');
        this.config.enum = enumInstance;
    }
    /** @internal */
    build(table) {
        return new PgEnumColumn(table, this.config);
    }
}
class PgEnumColumn extends PgColumn {
    static [entityKind] = 'PgEnumColumn';
    enum = this.config.enum;
    enumValues = this.config.enum.enumValues;
    constructor(table, config) {
        super(table, config);
        this.enum = config.enum;
    }
    getSQLType() {
        return this.enum.enumName;
    }
}
// Gratitude to zod for the enum function types
function pgEnum(enumName, values) {
    const enumInstance = Object.assign((name) => new PgEnumColumnBuilder(name, enumInstance), {
        enumName,
        enumValues: values,
        [isPgEnumSym]: true,
    });
    return enumInstance;
}

class PgInetBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgInetBuilder';
    constructor(name) {
        super(name, 'string', 'PgInet');
    }
    /** @internal */
    build(table) {
        return new PgInet(table, this.config);
    }
}
class PgInet extends PgColumn {
    static [entityKind] = 'PgInet';
    getSQLType() {
        return 'inet';
    }
}
function inet(name) {
    return new PgInetBuilder(name);
}

class PgIntegerBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgIntegerBuilder';
    constructor(name) {
        super(name, 'number', 'PgInteger');
    }
    /** @internal */
    build(table) {
        return new PgInteger(table, this.config);
    }
}
class PgInteger extends PgColumn {
    static [entityKind] = 'PgInteger';
    getSQLType() {
        return 'integer';
    }
    mapFromDriverValue(value) {
        if (typeof value === 'string') {
            return Number.parseInt(value);
        }
        return value;
    }
}
function integer(name) {
    return new PgIntegerBuilder(name);
}

class PgIntervalBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgIntervalBuilder';
    constructor(name, intervalConfig) {
        super(name, 'string', 'PgInterval');
        this.config.intervalConfig = intervalConfig;
    }
    /** @internal */
    build(table) {
        return new PgInterval(table, this.config);
    }
}
class PgInterval extends PgColumn {
    static [entityKind] = 'PgInterval';
    fields = this.config.intervalConfig.fields;
    precision = this.config.intervalConfig.precision;
    getSQLType() {
        const fields = this.fields ? ` ${this.fields}` : '';
        const precision = this.precision ? `(${this.precision})` : '';
        return `interval${fields}${precision}`;
    }
}
function interval(name, config = {}) {
    return new PgIntervalBuilder(name, config);
}

class PgMacaddrBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgMacaddrBuilder';
    constructor(name) {
        super(name, 'string', 'PgMacaddr');
    }
    /** @internal */
    build(table) {
        return new PgMacaddr(table, this.config);
    }
}
class PgMacaddr extends PgColumn {
    static [entityKind] = 'PgMacaddr';
    getSQLType() {
        return 'macaddr';
    }
}
function macaddr(name) {
    return new PgMacaddrBuilder(name);
}

class PgMacaddr8Builder extends PgColumnBuilder {
    static [entityKind] = 'PgMacaddr8Builder';
    constructor(name) {
        super(name, 'string', 'PgMacaddr8');
    }
    /** @internal */
    build(table) {
        return new PgMacaddr8(table, this.config);
    }
}
class PgMacaddr8 extends PgColumn {
    static [entityKind] = 'PgMacaddr8';
    getSQLType() {
        return 'macaddr8';
    }
}
function macaddr8(name) {
    return new PgMacaddr8Builder(name);
}

class PgRealBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgRealBuilder';
    constructor(name, length) {
        super(name, 'number', 'PgReal');
        this.config.length = length;
    }
    /** @internal */
    build(table) {
        return new PgReal(table, this.config);
    }
}
class PgReal extends PgColumn {
    static [entityKind] = 'PgReal';
    constructor(table, config) {
        super(table, config);
    }
    getSQLType() {
        return 'real';
    }
    mapFromDriverValue = (value) => {
        if (typeof value === 'string') {
            return Number.parseFloat(value);
        }
        return value;
    };
}
function real(name) {
    return new PgRealBuilder(name);
}

class PgSerialBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgSerialBuilder';
    constructor(name) {
        super(name, 'number', 'PgSerial');
        this.config.hasDefault = true;
        this.config.notNull = true;
    }
    /** @internal */
    build(table) {
        return new PgSerial(table, this.config);
    }
}
class PgSerial extends PgColumn {
    static [entityKind] = 'PgSerial';
    getSQLType() {
        return 'serial';
    }
}
function serial(name) {
    return new PgSerialBuilder(name);
}

class PgSmallIntBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgSmallIntBuilder';
    constructor(name) {
        super(name, 'number', 'PgSmallInt');
    }
    /** @internal */
    build(table) {
        return new PgSmallInt(table, this.config);
    }
}
class PgSmallInt extends PgColumn {
    static [entityKind] = 'PgSmallInt';
    getSQLType() {
        return 'smallint';
    }
    mapFromDriverValue = (value) => {
        if (typeof value === 'string') {
            return Number(value);
        }
        return value;
    };
}
function smallint(name) {
    return new PgSmallIntBuilder(name);
}

class PgSmallSerialBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgSmallSerialBuilder';
    constructor(name) {
        super(name, 'number', 'PgSmallSerial');
        this.config.hasDefault = true;
        this.config.notNull = true;
    }
    /** @internal */
    build(table) {
        return new PgSmallSerial(table, this.config);
    }
}
class PgSmallSerial extends PgColumn {
    static [entityKind] = 'PgSmallSerial';
    getSQLType() {
        return 'smallserial';
    }
}
function smallserial(name) {
    return new PgSmallSerialBuilder(name);
}

class PgTextBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgTextBuilder';
    constructor(name, config) {
        super(name, 'string', 'PgText');
        this.config.enumValues = config.enum;
    }
    /** @internal */
    build(table) {
        return new PgText(table, this.config);
    }
}
class PgText extends PgColumn {
    static [entityKind] = 'PgText';
    enumValues = this.config.enumValues;
    getSQLType() {
        return 'text';
    }
}
function text(name, config = {}) {
    return new PgTextBuilder(name, config);
}

class PgVarcharBuilder extends PgColumnBuilder {
    static [entityKind] = 'PgVarcharBuilder';
    constructor(name, config) {
        super(name, 'string', 'PgVarchar');
        this.config.length = config.length;
        this.config.enumValues = config.enum;
    }
    /** @internal */
    build(table) {
        return new PgVarchar(table, this.config);
    }
}
class PgVarchar extends PgColumn {
    static [entityKind] = 'PgVarchar';
    length = this.config.length;
    enumValues = this.config.enumValues;
    getSQLType() {
        return this.length === undefined ? `varchar` : `varchar(${this.length})`;
    }
}
function varchar(name, config = {}) {
    return new PgVarcharBuilder(name, config);
}

function alias(table, alias) {
    return new Proxy(table, new TableAliasProxyHandler(alias, false));
}

class CheckBuilder {
    name;
    value;
    static [entityKind] = 'PgCheckBuilder';
    brand;
    constructor(name, value) {
        this.name = name;
        this.value = value;
    }
    /** @internal */
    build(table) {
        return new Check(table, this);
    }
}
class Check {
    table;
    static [entityKind] = 'PgCheck';
    name;
    value;
    constructor(table, builder) {
        this.table = table;
        this.name = builder.name;
        this.value = builder.value;
    }
}
function check(name, value) {
    return new CheckBuilder(name, value);
}

class IndexBuilderOn {
    unique;
    name;
    static [entityKind] = 'PgIndexBuilderOn';
    constructor(unique, name) {
        this.unique = unique;
        this.name = name;
    }
    on(...columns) {
        return new IndexBuilder(columns, this.unique, false, this.name);
    }
    onOnly(...columns) {
        return new IndexBuilder(columns, this.unique, true, this.name);
    }
}
class IndexBuilder {
    static [entityKind] = 'PgIndexBuilder';
    /** @internal */
    config;
    constructor(columns, unique, only, name) {
        this.config = {
            name,
            columns,
            unique,
            only,
        };
    }
    concurrently() {
        this.config.concurrently = true;
        return this;
    }
    using(method) {
        this.config.using = method;
        return this;
    }
    asc() {
        this.config.order = 'asc';
        return this;
    }
    desc() {
        this.config.order = 'desc';
        return this;
    }
    nullsFirst() {
        this.config.nulls = 'first';
        return this;
    }
    nullsLast() {
        this.config.nulls = 'last';
        return this;
    }
    where(condition) {
        this.config.where = condition;
        return this;
    }
    /** @internal */
    build(table) {
        return new Index(this.config, table);
    }
}
class Index {
    static [entityKind] = 'PgIndex';
    config;
    constructor(config, table) {
        this.config = { ...config, table };
    }
}
function index(name) {
    return new IndexBuilderOn(false, name);
}
function uniqueIndex(name) {
    return new IndexBuilderOn(true, name);
}

class PgSchema {
    schemaName;
    static [entityKind] = 'PgSchema';
    constructor(schemaName) {
        this.schemaName = schemaName;
    }
    table = ((name, columns, extraConfig) => {
        return pgTableWithSchema(name, columns, extraConfig, this.schemaName);
    });
    view = ((name, columns) => {
        return pgViewWithSchema(name, columns, this.schemaName);
    });
    materializedView = ((name, columns) => {
        return pgMaterializedViewWithSchema(name, columns, this.schemaName);
    });
}
function isPgSchema(obj) {
    return is(obj, PgSchema);
}
function pgSchema(name) {
    if (name === 'public') {
        throw new Error(`You can't specify 'public' as schema name. Postgres is using public schema by default. If you want to use 'public' schema, just use pgTable() instead of creating a schema`);
    }
    return new PgSchema(name);
}

function getTableConfig(table) {
    const columns = Object.values(table[Table.Symbol.Columns]);
    const indexes = [];
    const checks = [];
    const primaryKeys = [];
    const foreignKeys = Object.values(table[PgTable.Symbol.InlineForeignKeys]);
    const uniqueConstraints = [];
    const name = table[Table.Symbol.Name];
    const schema = table[Table.Symbol.Schema];
    const extraConfigBuilder = table[PgTable.Symbol.ExtraConfigBuilder];
    if (extraConfigBuilder !== undefined) {
        const extraConfig = extraConfigBuilder(table[Table.Symbol.Columns]);
        for (const builder of Object.values(extraConfig)) {
            if (is(builder, IndexBuilder)) {
                indexes.push(builder.build(table));
            }
            else if (is(builder, CheckBuilder)) {
                checks.push(builder.build(table));
            }
            else if (is(builder, UniqueConstraintBuilder)) {
                uniqueConstraints.push(builder.build(table));
            }
            else if (is(builder, PrimaryKeyBuilder)) {
                primaryKeys.push(builder.build(table));
            }
            else if (is(builder, ForeignKeyBuilder)) {
                foreignKeys.push(builder.build(table));
            }
        }
    }
    return {
        columns,
        indexes,
        foreignKeys,
        checks,
        primaryKeys,
        uniqueConstraints,
        name,
        schema,
    };
}
function getViewConfig(view) {
    return {
        ...view[ViewBaseConfig],
        ...view[PgViewConfig],
    };
}
function getMaterializedViewConfig(view) {
    return {
        ...view[ViewBaseConfig],
        ...view[PgMaterializedViewConfig],
    };
}

export { Check, CheckBuilder, ForeignKeyBuilder, Index, IndexBuilder, IndexBuilderOn, PgBigInt53, PgBigInt53Builder, PgBigInt64, PgBigInt64Builder, PgBigSerial53, PgBigSerial53Builder, PgBigSerial64, PgBigSerial64Builder, PgBoolean, PgBooleanBuilder, PgChar, PgCharBuilder, PgCidr, PgCidrBuilder, PgColumn, PgColumnBuilder, PgCustomColumn, PgCustomColumnBuilder, PgDoublePrecision, PgDoublePrecisionBuilder, PgEnumColumn, PgEnumColumnBuilder, PgInet, PgInetBuilder, PgInteger, PgIntegerBuilder, PgInterval, PgIntervalBuilder, PgMacaddr, PgMacaddr8, PgMacaddr8Builder, PgMacaddrBuilder, PgMaterializedViewConfig, PgReal, PgRealBuilder, PgSchema, PgSerial, PgSerialBuilder, PgSmallInt, PgSmallIntBuilder, PgSmallSerial, PgSmallSerialBuilder, PgTable, PgText, PgTextBuilder, PgVarchar, PgVarcharBuilder, PgViewConfig, PrimaryKeyBuilder, UniqueConstraintBuilder, alias, bigint, bigserial, boolean, char, check, cidr, customType, doublePrecision, getMaterializedViewConfig, getTableConfig, getViewConfig, index, inet, integer, interval, isPgEnum, isPgSchema, macaddr, macaddr8, pgEnum, pgMaterializedViewWithSchema, pgSchema, pgTableWithSchema, pgViewWithSchema, real, serial, smallint, smallserial, text, uniqueIndex, varchar };
//# sourceMappingURL=index.mjs.map
